#!/usr/bin/perl

#   Generator of i8080 CPU Emulator

#   Tue 05 Aug 10:01:47 2003 by *HW*
#   --- finished and debugged completely

#------------------------------------------------------------------------------
($out_to_h = shift) or die "Please, specify header file name";
($out_to_c = shift) or die "Please, specify body file name";

#---[TOOLS]--------------------------------------------------------------------
sub dasm {undef @DASM unless scalar @_; push @DASM, @_}
sub pend {undef @PEND unless scalar @_; push @PEND, @_}
sub size {undef $SIZE unless scalar @_; $SIZE = shift}

sub pair_of {return {'B' => 'C', 'D' => 'E', 'H' => 'L'}->{$_[0]}}

#---[COLLECT]------------------------------------------------------------------
($pwd = $0) =~ s{[^:\\/]*?$}{}; @PASS = sort <$pwd*.pi>;

@PASS1 = grep {m{[:\\/]    1   [^:\\/]* \.pi$}x} @PASS;
@PASS2 = grep {m{[:\\/] [^0-9] [^:\\/]* \.pi$}x} @PASS;
@PASS3 = grep {m{[:\\/]    2   [^:\\/]* \.pi$}x} @PASS;

undef @PASS;

#------------------------------------------------------------------------------
for (@PASS1) {print STDERR "Loading $_ ...\n"; require $_};
for (@PASS2) {print STDERR "Loading $_ ...\n"; require $_};

#---[PARSE]--------------------------------------------------------------------
undef %DASM; undef %PEND;
for $item (split /[\n;]\s*/, $TABLE)
{
    ($at, $cmd, $op1, $op2) = split /\s+/, uc $item;
    die "'$item' has already been here as $PEND{$at}" if $PEND{$at};
    die "'$item' has already been here as $DASM{$at}" if $DASM{$at};
    $job = $cmd; # We may process $cmd somehow before searching for handlers

    size; dasm; pend;
    &{'_'.lc($job).'_'}($cmd, $op1, $op2);
    pend "r_PC += $SIZE" if $SIZE;
    pend "break;";

    $body = "\t".(join ";\n\t", @PEND); push @{$OPT{$body}}, $at;
    $PEND{$at} = "case 0x$at: // $item\n";
    $DASM{$at} = "case 0x$at: size = $SIZE; // $item\n"
               . "\tsprintf(cmd, "
               . join(', ', '"'.$DASM[0].'"', @DASM[1..$#DASM])
               . ");\n\tbreak;\n";
}

#------------------------------------------------------------------------------
while (($body, $code) = each %OPT)
{
    @code = sort @$code; # coagulate all code snippets (i.e. optimization)
    $PEND2{$code[0]} = join('', map {$PEND{$_}} @code).$body."\n";
}

#------------------------------------------------------------------------------
for (@PASS3) {print STDERR "Loading $_ ...\n"; require $_};

#---[FLUSH]--------------------------------------------------------------------
print STDERR "Flushing into $out_to_h and $out_to_c ...\n";

open H, ">$out_to_h" or die "Unable to create '$out_to_h'";
open C, ">$out_to_c" or die "Unable to create '$out_to_c'";

print H $INTERFACE; print C $BODY;

close H; close C;

#------------------------------------------------------------------------------
